var video, btnPlay, btnVolume, pbTrack, pbActual, pbHandle, spnTime, vidPlay, counter;
var volStep = 6;

function initVideo() {
	video = document.getElementsByTagName("video")[0];										// a video objektum
	video.controls = false;																	// kikapcsoljuk a bngsz sajt kontrolljt
	
	btnPlay = document.getElementById("vc_play");											// a lejtsz gomb
	btnPlay.addEventListener("click", playControl, false);									// kattintsra hvja meg a lejtsz fggvnyt
	video.addEventListener("click", playControl, false);									// ha a videra kattintanak, akkor is
	
	var btnForw = document.getElementById("vc_forw");										// a gyorsteker gombok
	if (btnForw) btnForw.addEventListener("click", jumpTime, false);						// s a hozzjuk kapcsolt fggvny
	var btnBack = document.getElementById("vc_back");
	if (btnBack) btnBack.addEventListener("click", jumpTime, false);
	var btnStart = document.getElementById("vc_start");
	if (btnStart) btnStart.addEventListener("click", jumpTime, false);
	var btnEnd = document.getElementById("vc_end");
	if (btnEnd) btnEnd.addEventListener("click", jumpTime, false);

	pbTrack  = document.getElementById("vc_progressbar");									// az llapotjelz sv								
	pbActual = document.getElementById("vc_pb_actual");										// itt tart a lejtszs
	pbHandle = document.getElementById("vc_pb_handle");										// a csszka
	
	pbTrack.addEventListener("click", function(evt) { setTime(evt); }, false);				// ha kattintanak az llapotjelzn
	pbHandle.addEventListener("mousedown", startHandlerMove, false);						// ha megfogjk a csszkt
	
	spnTime = document.getElementById("vc_act_time");										// ide rjuk az aktulis lejtszsi pontot
	spnTime.innerHTML = timeFormat(0);														// ami egyelre 0:00
	
	if (navigator.userAgent.indexOf("MSIE") > -1)											// a vide teljes hossza
		video.addEventListener("loadeddata", showDuration, false);							// IE alatt csak ksbb kapjuk meg
	else
		showDuration();																		// Chrome/Safari alatt nem megy a "loadeddata"
		
	btnVolume = document.getElementById("vc_volume");										// a hanger gomb
	btnVolume.addEventListener("click", setVolume, false);									// ami nmtknt funkcionl
	createVolumeControl();																	// ltrehozzuk a hanger szablyoz "plcikkat"
	showVolume();																			// s ki is sznezzk
}

function playControl() {
	if (video.paused) {																		// ha a vide ppen ll
		video.play();																		// elindtjuk a lejtszst
		startCounter();																		// elindtjuk a szmllt
		btnPlay.className = "pause";														// "pause"-ra vltoztatjuk a gombot
	} else {																				// klnben
		video.pause();																		// meglltjuk a lejtszst
		pauseCounter();																		// meglltjuk a szmllt
		btnPlay.className = "";																// visszavltoztatjuk a gomb kpt
	}
}

function startCounter() {
	counter = window.setInterval(function() {
				if (video.ended) {															// vge van a videnak?
					video.pause();															// lelltjuk a lejtszst
					pauseCounter();															// lelltjuk a szmllt
					delClassName(btnPlay, "pause");											// visszavltoztatjuk a gomb kpt
				}
				showProgressBar();															// mindenkppen frisstjk az llapotjelzt
			}, 50);																			// 50 ms-onknt visszatrnk
}

function pauseCounter() {
	window.clearInterval(counter);															// trljk az idztt
}

function showProgressBar() {
	var percent = video.currentTime / video.duration;										// hol tartunk %-ban?
	pbActual.style.width = (pbTrack.scrollWidth * percent) + "px";							// nyjtjuk a cskot
	pbHandle.style.left  = ((pbTrack.scrollWidth - pbHandle.scrollWidth) * percent) + "px";	// mozdtjuk a csszkt
	
	spnTime.innerHTML = timeFormat(video.currentTime);										// kiirjuk az aktulis pozci idejt
	
	if (video.paused && video.seeking)														// ha ppen ll, de mg "csvl"
		var t = setTimeout("showProgressBar();", 100);										// akkor mg visszanznk
}

function jumpTime() {
	var actTime = video.currentTime;														// jelenleg itt tartunk
	
	if (this.id == "vc_forw")
		actTime = Math.min(actTime + 5, video.duration);									// +5 mp, de legfeljebb a vgig
	if (this.id == "vc_back")
		actTime = Math.max(actTime - 5, 0);													// -5 mp
	if (this.id == "vc_start")
		actTime = 0;																		// elejre
	if (this.id == "vc_end")
		actTime = Math.max(actTime, video.duration - 5);									// vge eltt 5 mp, kivve, ha mr mgtte vagyunk
	
	if (actTime != video.currentTime) {														// ha vltozott az id
		video.currentTime = actTime;														// "tekerjk" a videban
		showProgressBar();																	// frisstjk az llapotjelzt
	}
}

function setTime(evt) {
	var percent = limitPercent((evt.pageX - absPosX(pbTrack)) / pbTrack.offsetWidth);		// hol kattintottak?
	video.currentTime = percent * video.duration;											// odatekerjk a videt
	showProgressBar();																		// frisstjk az llapotjelzt
}

function startHandlerMove() {
	vidPlay = !video.paused;																// ment vagy llt a vide?
	if (vidPlay) video.pause();																// ha ment, meglltjuk
	pauseCounter();																			// ahogyan a szmllt is
	
	document.onmousemove = function(evt) { setProgressBar(evt); };							// ha mozgatjk az egeret
	document.onmouseup   = stopHandlerMove;													// ha elengedik az egrgombot
}

function stopHandlerMove() {
	document.onmousemove = null;															// mr nem kell figyelnnk ezt a kt esemnyt
	document.onmouseup   = null;
	
	if (vidPlay) {																			// ha ment a lejtszs a csszka megfogsakor
		video.play();																		// elindtjuk a lejtszst
		startCounter();																		// elindtjuk a szmllt
	}
}

function setProgressBar(evt) {
	var percent = limitPercent((evt.pageX - absPosX(pbTrack)) / pbTrack.offsetWidth);		// a llapotsvon bell hol tart a csszka?
	video.currentTime = percent * video.duration;											// odatekerjk a videt

	pbActual.style.width = (pbTrack.scrollWidth * percent) + "px";							// nyjtjuk a cskot
	pbHandle.style.left  = ((pbTrack.scrollWidth - pbHandle.scrollWidth) * percent) + "px";	// mozdtjuk a csszkt

	spnTime.innerHTML = timeFormat(percent * video.duration);								// kiirjuk a pont idejt (majd ider a vide is)
}

function setVolume() {
	if (this.id == "vc_volume") {															// ha a gombra kattintottak
		video.muted = !video.muted															// vltunk a nmtott s a norml kztt
	} else {
		video.volume = (parseInt(this.id.replace("vol_", ""), 10)) / 10;					// belltjuk a hangert
		video.muted = false;																// megszntetjk a nmtst
	}
	
	showVolume();
}

function showVolume() {
	if (video.muted) {																		// ha nmtott
		btnVolume.className = "vol0";														// belltjuk a gombot
		for (var i = 0; i <= 10; i++)														// nullzzuk a hanger "pckket"
			document.getElementById("vol_" + i).className = "";
	} else {
		var v = video.volume;																// hangertl fggen belltjuk a gombot
		btnVolume.className = (v == 0 ? "vol0" : ((v < .4) ? "vol1": ((v < .8) ? "vol2" : "")));
		for (var i = 0; i <= 10; i++)														// sznezzk a "pckket"
			document.getElementById("vol_" + i).className = (v >= (i / 10) ? "selected" : "");
	}
}

function createVolumeControl() {
	var volList = document.getElementById("vc_volume_list");								// a hanger "lista"
	if (volList) {																			// ha van ilyen
		for (var i = 0; i <= 10; i++) {
			var listElem = document.createElement("li");									// ltrehozunk 11 elemet
			listElem.id = "vol_" + i;														// egyedi azonostval
			listElem.style.left = (i * volStep) + "px";										// egyms mell
			listElem.onclick = setVolume;													// kattintsra hangert lltunk
			volList.appendChild(listElem);													// hozzadjuk a listhoz
		}
	}
}

function showDuration() {
	document.getElementById("vc_tot_time").innerHTML = "/" + timeFormat(video.duration);	// kirjuk milyen hossz a vide
}

function limitPercent(percent) {
	return Math.min(Math.max(percent, 0), 1);												// csak 0 s 1 kztti rtkek lehetnek jk
}

function timeFormat(time) {
	time = Math.floor(time);																// formzva rjuk ki az idket (0:00)
	
	var min = Math.floor(time / 60);
	var sec = Math.floor(time % 60);
	
	return min + ":" + ((sec < 10) ? "0" + sec : sec);
}

function absPosX(obj) {																		// hol van az elem az oldalon
	var x = obj.offsetLeft;
	while (obj = obj.offsetParent)
		x += obj.offsetLeft;
	
	return x;
}

window.onload = initVideo;